Package org.gradle.api.tasks.compile

## Class JavaCompile

- java.lang.Object
- - org.gradle.api.internal.AbstractTask
  - - org.gradle.api.DefaultTask
    - - org.gradle.api.internal.ConventionTask
      - - org.gradle.api.tasks.SourceTask
        - - org.gradle.api.tasks.compile.AbstractCompile
          - - org.gradle.api.tasks.compile.JavaCompile

- All Implemented Interfaces:
    `Comparable<Task>`, `org.gradle.api.internal.DynamicObjectAware`, `org.gradle.api.internal.IConventionAware`, `org.gradle.api.internal.TaskInternal`, `org.gradle.api.internal.tasks.compile.HasCompileOptions`, `ExtensionAware`, `Task`, `PatternFilterable`, `org.gradle.util.Configurable<Task>`
  Direct Known Subclasses:
    `PlatformJavaCompile`

      @CacheableTask
      public class JavaCompile
      extends AbstractCompile
      implements org.gradle.api.internal.tasks.compile.HasCompileOptions

  Compiles Java source files.

           plugins {
               id 'java'
           }

           tasks.withType(JavaCompile) {
               //enable compilation in a separate daemon process
               options.fork = true
           }

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Task

      `Task.Namer`

  - ### Field Summary

    - ### Fields inherited from interface org.gradle.api.Task

      `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JavaCompile()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `compile​(IncrementalTaskInputs inputs)` | Deprecated. Left for backwards compatibility.
    `protected void` | `compile​(InputChanges inputs)` | Compile the sources, taking into account the changes reported by inputs.
    `FileCollection` | `getClasspath()` | Returns the classpath to use to compile the source files.
    `protected org.gradle.internal.file.Deleter` | `getDeleter()` |
    `protected org.gradle.api.internal.tasks.compile.incremental.IncrementalCompilerFactory` | `getIncrementalCompilerFactory()` |
    `Property<JavaCompiler>` | `getJavaCompiler()` | Configures the java compiler to be used to compile the Java source.
    `protected org.gradle.internal.jvm.JavaModuleDetector` | `getJavaModuleDetector()` |
    `protected org.gradle.api.internal.tasks.JavaToolChainFactory` | `getJavaToolChainFactory()` |
    `ModularitySpec` | `getModularity()` | Returns the module path handling of this compile task.
    `CompileOptions` | `getOptions()` | Returns the compilation options.
    `protected JavaPlatform` | `getPlatform()` | Deprecated.
    `protected ProjectLayout` | `getProjectLayout()` |
    `FileTree` | `getSource()` | Returns the source for this task, after the include and exclude patterns have been applied.
    `protected File` | `getSourceClassesMappingFile()` | The Groovy source-classes mapping file.
    `protected FileTree` | `getSources()` | Deprecated.
    `protected FileCollection` | `getStableSources()` | The sources for incremental change detection.
    `JavaToolChain` | `getToolChain()` | Deprecated.
    `void` | `setToolChain​(JavaToolChain toolChain)` | Deprecated.

    - ### Methods inherited from class org.gradle.api.tasks.compile.AbstractCompile

      `getDestinationDir, getDestinationDirectory, getSourceCompatibility, getTargetCompatibility, setClasspath, setDestinationDir, setDestinationDir, setSourceCompatibility, setTargetCompatibility`

    - ### Methods inherited from class org.gradle.api.tasks.SourceTask

      `exclude, exclude, exclude, exclude, getExcludes, getIncludes, getPatternSetFactory, include, include, include, include, setExcludes, setIncludes, setSource, setSource, source`

    - ### Methods inherited from class org.gradle.api.internal.ConventionTask

      `conventionMapping, conventionMapping, getConventionMapping`

    - ### Methods inherited from class org.gradle.api.DefaultTask

      `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

    - ### Methods inherited from class org.gradle.api.internal.AbstractTask

      `appendParallelSafeAction, getAsDynamicObject, getConvention, getIdentityPath, getImpliesSubProjects, getOnlyIf, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isEnabled, isHasCustomActions, prependParallelSafeAction, setImpliesSubProjects, setLoggerMessageRewriter`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.gradle.api.Task

      `getConvention`

- - ### Constructor Detail

    - #### JavaCompile

          public JavaCompile()

  - ### Method Detail

    - #### getSource

          @ReplacedBy("stableSources")
          public FileTree getSource()

      Returns the source for this task, after the include and exclude patterns have been applied. Ignores source files which do not exist.

      The `PathSensitivity` for the sources is configured to be `PathSensitivity.ABSOLUTE`. If your sources are less strict, please change it accordingly by overriding this method in your subclass.

      Overrides:
        `getSource` in class `SourceTask`
      Returns:
        The source.

    - #### getSources

          @Deprecated
          @Internal
          protected FileTree getSources()

      Deprecated.
      This method is overwritten by the Android plugin < 3.6. We add it here as hack so we can add the source from that method to stableSources. DO NOT USE!
      Since:
        6.0

    - #### getToolChain

          @Deprecated
          public JavaToolChain getToolChain()

      Deprecated.
      Returns the tool chain that will be used to compile the Java source.
      Returns:
        The tool chain.

    - #### setToolChain

          @Deprecated
          public void setToolChain​(JavaToolChain toolChain)

      Deprecated.
      Sets the tool chain that should be used to compile the Java source.
      Parameters:
        `toolChain` - The tool chain.

    - #### getJavaCompiler

          @Incubating
          @Optional
          public Property<JavaCompiler> getJavaCompiler()

      Configures the java compiler to be used to compile the Java source.
      Since:
        6.7
      See Also:
        `JavaToolchainSpec`

    - #### compile

          @Deprecated
          protected void compile​(IncrementalTaskInputs inputs)

      Deprecated.
      Left for backwards compatibility.
      Compile the sources, taking into account the changes reported by inputs.

    - #### compile

          @Incubating
          protected void compile​(InputChanges inputs)

      Compile the sources, taking into account the changes reported by inputs.
      Since:
        6.0

    - #### getIncrementalCompilerFactory

          @Inject
          protected org.gradle.api.internal.tasks.compile.incremental.IncrementalCompilerFactory getIncrementalCompilerFactory()

    - #### getJavaModuleDetector

          @Inject
          protected org.gradle.internal.jvm.JavaModuleDetector getJavaModuleDetector()

    - #### getJavaToolChainFactory

          @Inject
          protected org.gradle.api.internal.tasks.JavaToolChainFactory getJavaToolChainFactory()

    - #### getDeleter

          @Inject
          protected org.gradle.internal.file.Deleter getDeleter()

    - #### getProjectLayout

          @Inject
          protected ProjectLayout getProjectLayout()

    - #### getPlatform

          @Deprecated
          protected JavaPlatform getPlatform()

      Deprecated.

    - #### getSourceClassesMappingFile

          @LocalState
          @Incubating
          protected File getSourceClassesMappingFile()

      The Groovy source-classes mapping file. Internal use only.
      Since:
        6.5

    - #### getModularity

          @Incubating
          public ModularitySpec getModularity()

      Returns the module path handling of this compile task.
      Since:
        6.4

    - #### getOptions

          public CompileOptions getOptions()

      Returns the compilation options.
      Specified by:
        `getOptions` in interface `org.gradle.api.internal.tasks.compile.HasCompileOptions`
      Returns:
        The compilation options.

    - #### getClasspath

          @CompileClasspath
          @Incremental
          public FileCollection getClasspath()

      Description copied from class: `AbstractCompile`
      Returns the classpath to use to compile the source files.
      Overrides:
        `getClasspath` in class `AbstractCompile`
      Returns:
        The classpath.

    - #### getStableSources

          @Incubating
          @SkipWhenEmpty
          @IgnoreEmptyDirectories
          @PathSensitive(RELATIVE)
          @InputFiles
          protected FileCollection getStableSources()

      The sources for incremental change detection.
      Since:
        6.0